%********************************************
%	Function OFm : objective function
%	for EP1 project at LENI
%********************************************
%	01.03.00 - BR
%	22.03.00 - etc.
%	08.01.01 - for optimize v4.40
%********************************************
%	Version post-processing - BRof.m
%********************************************

disp (' Calculated analytical function for display and best genome - BRof.m');
disp (' *******************************************************************');
% disp (' ');

slope = 1000.0;
nvar = BestGenome.inXsize;
nfun = 15;
	Obj_Func = zeros(1,nfun);
	Xval = ones(nvar,nfun);
	XX   = ones(1,nfun);

	Xval(:,1) = BestGenome.inXval(:);
	Xval(:,2) = 0.0;
	Xval(:,3) = 0.1;
	Xval(:,4) = 0.2;
	Xval(:,5) = 0.3;
	Xval(:,6) = 0.4;
	Xval(:,7) = 0.5;
	Xval(:,8) = 0.6;
	Xval(:,9) = 0.7;
	Xval(:,10) = 0.75;
	Xval(:,11) = 0.8;
	Xval(:,12) = 0.85;
	Xval(:,13) = 0.9;
	Xval(:,14) = 0.95;
	Xval(:,15) = 1.0;
		Xval(11,2:nfun) = max(min( 1,xmax(11)),xmin(11));
		Xval(12,2:nfun) = max(min( 2,xmax(12)),xmin(12));
		Xval(13,2:nfun) = max(min( 1,xmax(13)),xmin(13));
		Xval(14,2:nfun) = max(min( 0,xmax(14)),xmin(14));
		Xval(15,2:nfun) = max(min( 1,xmax(15)),xmin(15));
	XX(:) = Xval(1,:);
%Xval
%XX
for j = 1:nfun
for i = 1:nvar,
	inX_SXi = Xval(i,j);
	if     i == 12
		inX_SXi = inX_SXi - 1;		% - 4;
	elseif i == 14
		inX_SXi = inX_SXi + 1;		% + 4;
	end
	Obj_Func(j) = Obj_Func(j) + slope*((inX_SXi-0.8)*(inX_SXi-0.9))^2 + (1/slope)*inX_SXi;	%	Theee OF !
end;
end;
%Obj_Func
subplot(3,1,3); axis([ 0.7 1 0.99*Xval(2,11) 1.01*Xval(2,11)]); grid on; xlabel('XX'); ylabel('Calculated OF');
for j = 2:nfun
	DispNum (Obj_Func(j),   ['Obj_Func(',num2str(j),')_Value_calculated'], 'XX=',num2str(XX(j)));
	subplot(3,1,3);	hold on; plot(XX(j), Obj_Func(j), 'bh');			%	plot of calc OF !
end;
for i = 1:nvar
	DispNum (Obj_Func(1),   'Obj_Func_Value_calc_on_best_genome', ['Xval(',num2str(i),',1)='],num2str(Xval(i,1)));
	subplot(3,1,3);	hold on; plot(Xval(i,1), Obj_Func(1), 'r.');			%	plot of calc OF !
end;
%	DispNum (OF_side(4),    'Obj_Func_Value_minimalise ');

%********************************************
%	end function OFm
%********************************************
